- name: Creating user pgbackrest
  user:
   name: "{{ pgbackrest_user }}"

- name: Create pgbackrest directories
  file:
    path: "{{ item.path }}"
    state: "{{ item.state }}"
    mode: "{{ item.mode }}"
    owner: "{{ pgbackrest_user }}"
    group: "{{ pgbackrest_user }}"
  with_items:
    - "{{ pgbackrest_path }}"
  changed_when: false

- name: Change pgbackrest home directory permission
  file:
    path: "{{ pgbackrest_home }}"
    state: directory 
    owner: "{{ pgbackrest_user }}"
    group: "{{ pgbackrest_user }}"



- name: copy configuration file
  template:
    src: "{{ pgbackrest_conf_src }}"
    dest: "{{ pgbackrest_conf_dest }}"
    mode: 0640
    owner: "{{ pgbackrest_user }}"
    group: "{{ pgbackrest_user }}"
  


- name: Configure pgbackrest repository
  package:
    name: "{{ pgbackrest_repo }}"

- name: update yum
  yum:
   name: "*"
   state: latest

- name: Install pgbackrest packages
  package:
    name: "{{ item }}"
    state: present
    update_cache: yes
  with_items:
    - "{{ pgbackrest_pkgs }}"


- name: generate ssh keys
  become_user: "{{ pgbackrest_user }}"
  command: 'ssh-keygen -f {{ pgbackrest_home }}/.ssh/id_rsa -t rsa -b 4096 -N ""'
  args:
    creates: '{{ pgbackrest_home }}/.ssh/id_rsa'

- name: Copy repository public key to db servers
  command: 'cat {{ pgbackrest_home }}/.ssh/id_rsa.pub'
  changed_when: false
  register: repo_ssh_keys

- name: create cronjobs for backup
  cron:
    name: "{{ item.name }}"
    minute: "{{ item.minute }}"
    hour: "{{ item.hour }}"
    weekday: "{{ item.weekday }}"
    job: "{{ item.command }}"
  with_items:
    - "{{ cron_jobs }}"
  tags:
    - test12


- name: copy ssh config file
  template:
    src: "{{ ssh_conf_src }}"
    dest: "{{ ssh_conf_dest }}"
    mode: 0640
    owner: "{{ pgbackrest_user }}"
    group: "{{ pgbackrest_user }}"
  tags:
    - testssh
  
  

